#include <iostream>
#include <fstream>
#include <ctime>
#include <vector>
#include <cassert>
#include <map>
#include <algorithm>
#include <cmath>
#include <string>
#include <limits.h>

using namespace std;

string A, B;
short N, M;

vector<vector<double> > D;

void validate_input()
{
	assert(1 <= N && N <= 200);
	assert(1 <= M && M <= 200);

	assert(A.length() == N);
	assert(B.length() == M);
}

double res(short i, short j)
{
	if (D[i+1][j+1] < INT_MAX - 10.0)
		return D[i+1][j+1];

	double r = INT_MAX;
	if (i == -1 || j == -1)
	{
		r = sqrt(i + 1.0) + sqrt(j + 1.0);
	}	
	else
	{
		if (A[i] == B[j])
			r = res(i-1, j-1);

		// remove in A
		for (int k = i - 1;k >= -1;k--)
			r = min(r, sqrt(i - k) + res(k, j));

		// remove in B
		for (int k = j - 1;k >= -1;k--)
			r = min(r, (double)sqrt(j - k) + res(i, k));
	}


	D[i+1][j+1] = r;
	return r;
}

int main(int argc, char *argv[])
{
	freopen("editor.in", "r", stdin);
	//freopen("editor.out.gs", "w", stdout);

	int tc;
	cin >>tc;

	cout.setf(ios_base::fixed);
	cout.precision(2);
	for (int cc = 0;cc < tc;cc++)
	{
		D.clear();
		
		cin >>N >>M >>A >>B;
		D.resize(N + 1, vector<double>(M + 1, INT_MAX));
		validate_input();
		cout <<res(N-1, M-1) <<endl;
	}

	return 0;
}
