#include<iostream>
#include<cstdio>
#include<cstdlib>
#include<algorithm>
#include<vector>
#include<string>
#include<set>
#include<map>
#include<cmath>
#include<memory.h>
#include<assert.h>
using namespace std;
typedef long long ll;
typedef long double ld;

const int N = 12345;
const int MXD = 300;

int inf = 2111111111;

int a[N];
int b[N];

int n, K, D, m, oldn;

void pre(int t[N][MXD]){
    //сортировка каждого блока
    for(int i=0;i<n;i+=K){
        int *c = b+i;
        for(int j=0;j<K;++j) c[j] = i+j;
        sort(c,c+K,[](int i1, int i2){return a[i1]<a[i2];});
    }
    
    for(int i=0;i<n;++i) fill(t[i], t[i]+D, inf);
    
    //подсчёт ответов для [L..r] за D*(K + DK) = ND
    for(int kr=0,R=0 ;kr<D; ++kr,R+=K){
        for(int r=R; r<R+K; ++r){
            int x = inf;
            for(int l=R;l<r;++l) x = min(x, abs(a[l]-a[r]));
            t[r][kr] = x;
        }
        for(int kl=kr-1,L=R-K; kl>=0; --kl,L-=K){
            for(int l=L,r=R; r<R+K; ++r){
                while(l<L+K && a[b[l]]<a[b[r]]) ++l;
                int x1 = l<L+K ? a[b[l]]-a[b[r]] : inf;
                int x2 = l>L ? a[b[r]]-a[b[l-1]] : inf;
                int &x = t[b[r]][kl];
                x = min(x, min(x1,x2));
            }
        }
        
        for(int r=R+1; r<R+K; ++r) for(int kl=0;kl<=kr;++kl) t[r][kl] = min(t[r][kl], t[r-1][kl]);
        
        for(int r=R; r<R+K; ++r)
        for(int kl=kr-1; kl>=0; --kl) t[r][kl] = min(t[r][kl], min(t[r][kl+1], t[R-1][kl]));
    }
}

int t1[N][MXD];
int t2[N][MXD];
void init1(){
    scanf("%d",&n);
    assert(2<=n && n<=10000);
    for(int i=0;i<n;++i){
        scanf("%d",&a[i]);
        assert(-1000000000<=a[i] && a[i]<=1000000000);
    }
    scanf("%d",&m);
    assert(1<=m && m<=100000);    

    //K*D = N, K - размер блока
    K = max(1,int(sqrt(n)*0.35));
    oldn = n;
    while(n%K) ++n; //расширяем для удобства
    D = n/K;
    assert(D<MXD);
    
    
    reverse(a,a+n);
    pre(t2);
    reverse(a,a+n);
    pre(t1);
}


void solve(){
    int ans = 0, x;
    #define upd(i) if(l<=i && i<=r){if(li!=-1) res=min(res, a[i]-a[li]); li=i;}
    while(m--){
        int l, r;
        scanf("%d%d",&l,&r);
        assert(0<=l && l<oldn);
        assert(0<=r && r<oldn);
        l = (l+ans%oldn)%oldn;
        r = (r+ans%oldn)%oldn;
        assert(0<=l && l<r && r<oldn);
        int kl = l/K, kr = r/K;
        if(kl==kr){
            //отрезок запроса мал и входит в целый блок
            int *p = b+kl*K;
            int li = -1;
            int res = inf;
            for(int i=0;i<K;++i) { x=p[i]; upd(x); }
            ans = res;
        }else{
            //отрезок запроса разбивается на блоки
            //берём предпосчитанные значения
            int res = min(t2[n-1 - l][D-1 - (kr-1)], t1[r][kl+1]);
            int li = -1;
            int *p1 = b+kl*K;
            int *p2 = b+kr*K;
            /*
              методом двух указателей (аля сортировка слиянием) 
              обрабатываем элементы по краям запроса
            */
            for(int i=0,j=0; i<K || j<K;){
                if(i<K && (j==K || a[p1[i]]<a[p2[j]])){
                    { x=p1[i]; upd(x); }
                    ++i;
                }else{
                    { x=p2[j]; upd(x); }
                    ++j;
                }
            }
            ans = res;
        }
        printf("%d\n",ans);
    }
}

int main(){
    freopen("fairyland.in","r",stdin); //freopen("output.txt","w",stdout);
    
    int tt;
    scanf("%d",&tt);
    while(tt--){
        init1();
        solve();
    }
    
    return 0;
}


