#include<iostream>
#include<cstdio>
#include<cstdlib>
#include<algorithm>
#include<vector>
#include<string>
#include<set>
#include<map>
#include<cmath>
#include<memory.h>
#include<assert.h>
using namespace std;
typedef long long ll;
typedef long double ld;

const int N = 12345;
const int T = (1<<15)+123;

int inf = 2111111111;

int a[N];
vector<int> t1[N];
vector<int> t2[N];
int b[N];

int n, K, m, oldn;
int tl[T], tr[T], d;
void pre(){
    memset(tl, -1, sizeof(tl[0])*d*2);
    memset(tr, 63, sizeof(tr[0])*d*2);
}


/*
дерево отрезков позволяет добавить элемент во множество и попутно ответить,
какие элементы в нём рядом слева и справа
*/
void add(int i, int &l, int &r){
    l = -1; r = inf;
    int p = i;
    i+=d;
    tl[i] = tr[i] = p;
    do{
        if(i&1){
            if(l<tl[i^1]) l=tl[i^1];
        }else{
            if(r>tr[i^1]) r=tr[i^1];
        }
        i>>=1;
        if(tl[i]<p) tl[i]=p;
        if(tr[i]>p) tr[i]=p;
    }while(i>1);
}

void init1(){
    scanf("%d",&n);
    assert(2<=n && n<=10000);
    for(int i=0;i<n;++i){
        scanf("%d",&a[i]);
        assert(-1000000000<=a[i] && a[i]<=1000000000);
    }
    scanf("%d",&m);
    assert(1<=m && m<=100000);    

    //K*D = N, K - размер блока
    K = sqrt(n);
    //K = sqrt(n*n*log2(n)/m/2);
    oldn = n;
    while(n%K) ++n; //расширяем для удобства
    
    vector<pair<int,int>> v(n);
    vector<int> w(n);
    for(int i=0;i<n;++i) v[i]={a[i],i};
    sort(v.begin(), v.end());
    for(int i=0;i<n;++i) w[v[i].second] = i;
    
    //сортировка каждого блока
    for(int i=0;i<n;i+=K){
        int *c = b+i;
        for(int j=0;j<K;++j) c[j] = i+j;
        sort(c,c+K,[](int i1, int i2){return a[i1]<a[i2];});
    }
    
    for(d=2;d<n;d<<=1);
    for(int i=0;i<n;++i){
        t1[i].assign(n/K,inf);
        t2[i].assign(n/K,inf);
    }
    
    //подсчёт ответов для [L..r] за N*D*logN
    for(int i=0;i<n;i+=K){
        pre();
        int res = inf;
        for(int j=i;j<n;++j){
            int l,r;
            add(w[j], l, r);
            if(l>=0) res = min(res, a[j]-v[l].first);
            if(r<n) res = min(res, v[r].first-a[j]);
            t1[j][i/K] = res;
        }
    }
    
    //подсчёт ответов для [l..R]
    for(int j=K-1;j<n;j+=K){
        pre();
        int res = inf;
        for(int i=j;~i;--i){
            int l,r;
            add(w[i], l, r);
            if(l>=0) res = min(res, a[i]-v[l].first);
            if(r<n) res = min(res, v[r].first-a[i]);
            t2[i][j/K] = res;
        }
    }
}


void solve(){
    int ans = 0, x;
    #define upd(i) if(l<=i && i<=r){if(li!=-1) res=min(res, a[i]-a[li]); li=i;}
    while(m--){
        int l, r;
        scanf("%d%d",&l,&r);
        assert(0<=l && l<oldn);
        assert(0<=r && r<oldn);
        l = (l+ans%oldn)%oldn;
        r = (r+ans%oldn)%oldn;
        assert(0<=l && l<r && r<oldn);
        int kl = l/K, kr = r/K;
        if(kl==kr){
            //отрезок запроса мал и входит в целый блок
            int *p = b+kl*K;
            int li = -1;
            int res = inf;
            for(int i=0;i<K;++i) { x=p[i]; upd(x); }
            ans = res;
        }else{
            //отрезок запроса разбивается на блоки
            //берём предпосчитанные значения
            int res = min(t2[l][kr-1], t1[r][kl+1]);
            int li = -1;
            int *p1 = b+kl*K;
            int *p2 = b+kr*K;
            /*
              методом двух указателей (аля сортировка слиянием) 
              обрабатываем элементы по краям запроса
            */
            for(int i=0,j=0; i<K || j<K;){
                if(i<K && (j==K || a[p1[i]]<a[p2[j]])){
                    { x=p1[i]; upd(x); }
                    ++i;
                }else{
                    { x=p2[j]; upd(x); }
                    ++j;
                }
            }
            ans = res;
        }
        printf("%d\n",ans);
    }
}

int main(){
    freopen("fairyland.in","r",stdin); //freopen("output.txt","w",stdout);
    
    int tt;
    scanf("%d",&tt);
    while(tt--){
        init1();
        solve();
    }
    
    return 0;
}

