#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <cmath>

struct Point{
    long long x, y;
};

bool inside(Point l, Point r, Point p)
{
    return 1ll * l.x * (r.y - p.y) + 1ll * r.x * (p.y - l.y) + 1ll * p.x * (l.y - r.y) >= 0;
}

long long d(Point a, Point b, Point c)
{
    return (c.x - a.x) * (b.y - a.y) - (c.y - a.y) * (b.x - a.x);
}

using namespace std;

int main()
{
    freopen("hit.in", "r", stdin);
//     freopen("hit2.out", "w", stdout);

    int t;
    cin >> t;
    while(t--)
    {
        int i, j, n, m;
        cin >> n >> m;
        vector<Point> p(n);
        for(i = 0; i < n; i++)
            cin >> p[i].x >> p[i].y;
        int zero_id = 0;
        for(i = 1; i < n; i++)
            if(p[i].x < p[zero_id].x || (p[i].x == p[zero_id].x && p[i].y < p[zero_id].y))
                zero_id = i;
        Point zero = p[zero_id];
        rotate (p.begin(), p.begin() + zero_id, p.end());
        for(i = 0; i < n; i++)
        {
            p[i].x -= zero.x;
            p[i].y -= zero.y;
        }
        p.push_back(p[0]);
        double an1 = atan2(p[1].y, p[1].x);
        double an2 = atan2(p[2].y, p[2].x);
        if(an1 >= an2)
            reverse(p.begin(), p.end());
        for(i = 0; i < m; i++)
        {
            long long x, y;
            cin >> x >> y;
            x = x - zero.x;
            y = y - zero.y;
            if((x < 0) || ((x == 0) && (y < 0)))
            {
                cout << "Nope" << endl;
                continue;
            }
            bool found = false;
            for(j = 1; j < n - 1; j++)
            {
                Point l = p[j];
                Point r = p[j + 1];
                Point pt;
                pt.x = x;
                pt.y = y;
                long long d1 = d(p[0], l, pt);
                long long d2 = d(p[0], r, pt);
                if(((d1 <= 0) && (d2 >= 0)) || ((d1 >= 0) && (d2 <= 0)))
                    if(inside(l, r, pt))
                    {
                        found = true;
                        break;
                    }
            }
            if(found)
                cout << "Yeap" << endl;
            else
                cout << "Nope" << endl;
        }
    }

    return 0;
}

