#include<iostream>
#include<cstdio>
#include<cstdlib>
#include<algorithm>
#include<vector>
#include<string>
#include<set>
#include<map>
#include<cmath>
#include<memory.h>
#include<assert.h>
using namespace std;
typedef long long ll;
typedef long double ld;

const int N = 1e6+6;

ld f1(ld x){
    return sin(x) - x + 1;
}

ld f2(ld x){
    return -pow(3.0, 1+2*x-x*x) - x*x + 4*x + 8;
}

ld r1,r2,r3,r4;

ld root(ld l, ld r, ld(*f)(ld)){
    for(int it=222;it;--it){
        ld m = (l+r)/2;
        if(f(m)>0) r = m; else l = m;
    }
    return (l+r)/2;
}

ld intrsct(ld l, ld r){
    for(int it=222;it;--it){
        ld m = (l+r)/2;
        if(f1(m)>f2(m)) l = m; else r = m;
    }
    return (l+r)/2;
}

ld area1(ld a, ld b){
    return (-cos(b)-b*b/2+b) - (-cos(a)-a*a/2+a);
}

ld area2(ld a, ld b){
    int n = 10000;
    ld h = (b-a)/n;
    ld s = 0;
    for(int i=0;i<n;++i){
        ld x1 = i*h + a;
        ld x2 = (i+1)*h + a;
        s+=(f2(x1)+f2(x2))/2*h;
    }
    return s;
}

int main(){
    freopen("integral.in","r",stdin);// freopen("integral.out","w",stdout);
    
    cout.precision(6);
    
    r1 = root(3, 1.5, f1); 
    r2 = root(-2, -1, f2);
    r3 = root(7, 4, f2);
    
    r4 = intrsct(-2,-1);
    
    int t;
    cin>>t;
    while(t--){
        ld L, R;
        cin>>L>>R;
        L = max(L, r2);
        R = min(R, r1);
        ld ans = 0;
        if(L<R && L<r4){
            ans+=area2(L, min(r4,R));
            L = r4;
        }
        if(L<R && L<r1){
            ans+=area1(L, min(r1,R));
        }
        cout<<fixed<<ans<<endl;
    }
    
    return 0;
}



