#include<iostream>
#include<cstdio>
#include<cstdlib>
#include<algorithm>
#include<vector>
#include<string>
#include<set>
#include<map>
#include<cmath>
#include<memory.h>
#include<assert.h>
using namespace std;
typedef long long ll;
typedef long double ld;

const int N = 1e6+6;
int mod = 1e9+7;

int gcd(int x, int y){
    while(x&&y) x>y?x%=y:y%=x;
    return x+y;
}

int mpow(ll a, ll b, int mod){
    ll r = 1;
    while(b){
        if(b&1) r=r*a%mod;
        a=a*a%mod;
        b>>=1;
    }
    return r%mod;
}

ll inv(ll a, ll mod){
    if(a==1) return 1;
    ll x = inv(mod%a, a);
    return mod-mod*x/a;
}

vector<pair<int,int>> fact(int x){
    vector<pair<int,int>> res;
    for(int d=2;x>1;++d){
        if(d*d>x) d=x;
        if(x%d==0){
            res.push_back({d,0});
            while(x%d==0){
                x/=d;
                res.back().second++;
            }
        }
    }
    return res;
}

ll gg(int a, int b, int q){
    q = (q%b+b)%b;
    ///z = 0 (mod a);
    ///z = q (mod b);
    ll z = q*inv(a, b)%b * a;
    assert(z%a==0);
    assert(z%b==q);
    return z;
}

void solve(){
    int a, b;
    scanf("%d%d",&a,&b);
    assert(gcd(a,b)==1);
    auto fa = fact(a);
    auto fb = fact(b);
    ll res = 1;
    for(auto p : fa){
        ll z = gg(a, b, -p.second);
        res = res*mpow(p.first, z, mod)%mod;
    }
    for(auto p : fb){
        ll z = gg(b, a, -p.second);
        res = res*mpow(p.first, z, mod)%mod;
    }
    
    res=res*a%mod*b%mod;
    
    printf("%d\n",(int)res);
}


int main(){
    //freopen("input.txt","r",stdin);// freopen("output.txt","w",stdout);
    
    int t;
    scanf("%d",&t);
    assert(1<=t && t<=10000);
    while(t--) solve();
    
    
    return 0;
}

